unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, DB, Forms, Controls, Graphics, Dialogs, DBGrids, StdCtrls, ZConnection, ZDataset, ZSqlProcessor, DateTimePicker,
  DateUtils;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    ds: TDataSource;
    dtpd: TDateTimePicker;
    dtpst: TDateTimePicker;
    dtpet: TDateTimePicker;
    DBGrid1: TDBGrid;
    eremarks: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    zconn: TZConnection;
    zqlist: TZQuery;
    zquery: TZQuery;
    zstruct: TZSQLProcessor;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure zqlistAfterScroll(DataSet: TDataSet);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button3Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  zquery.SQL.Clear;
  zquery.SQL.Add(' select sum(julianday(Czas_zakonczenia)-julianday(Czas_rozpoczecia)) total from godziny ');
  zquery.Open;
  ShowMessage(FormatDateTime('[hh]:nn', zquery.FieldByName('total').AsFloat, [fdoInterval]));
  zquery.Close;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  y, m, d, h, n, s, ms: Word;
begin
  if dtpst.Time > dtpet.Time then
  begin
    ShowMessage('The ending time must be less than the starting time');
    exit;
  end;
  zquery.SQL.Clear;
  zquery.SQL.Add(' insert into godziny (MiesiacID, Czas_rozpoczecia, Czas_zakonczenia, Uwagi) ');
  zquery.SQL.Add(' values (:mid, :cr, :cz, :uw) ');
  zquery.ParamByName('mid').AsInteger := 1;
  zquery.ParamByName('uw').AsString := eremarks.Text;
  DecodeDate(dtpd.Date, y, m, d);
  DecodeTime(dtpst.Time, h, n, s, ms);
  zquery.ParamByName('cr').AsDateTime := EncodeDateTime(y, m, d, h, n, 0, 0);
  DecodeTime(dtpet.Time, h, n, s, ms);
  zquery.ParamByName('cz').AsDateTime := EncodeDateTime(y, m, d, h, n, 0, 0);
  zquery.ExecSQL;
  zqlist.Refresh;
  zqlist.Last;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  y, m, d, h, n, s, ms: Word;
begin
  if dtpst.Time > dtpet.Time then
  begin
    ShowMessage('The ending time must be less than the starting time');
    exit;
  end;
  zquery.SQL.Clear;
  zquery.SQL.Add(' update godziny set Czas_rozpoczecia=:cr, Czas_zakonczenia=:cz, uwagi=:uw where GodzinyID=:id ');
  zquery.ParamByName('id').AsInteger := zqlist.FieldByName('GodzinyID').AsInteger;
  zquery.ParamByName('uw').AsString := eremarks.Text;
  DecodeDate(dtpd.Date, y, m, d);
  DecodeTime(dtpst.Time, h, n, s, ms);
  zquery.ParamByName('cr').AsDateTime := EncodeDateTime(y, m, d, h, n, 0, 0);
  DecodeTime(dtpet.Time, h, n, s, ms);
  zquery.ParamByName('cz').AsDateTime := EncodeDateTime(y, m, d, h, n, 0, 0);
  zquery.ExecSQL;
  zqlist.Refresh;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  //time controls
  dtpst.AutoSize := False;
  dtpst.DateMode := dmNone;
  dtpst.Kind := dtkTime;
  dtpst.TimeDisplay := tdHM;
  dtpet.AutoSize := False;
  dtpet.DateMode := dmNone;
  dtpet.Kind := dtkTime;
  dtpet.TimeDisplay := tdHM;
  //db
  zconn.Connect;
  zstruct.Execute;
  zqlist.Open;
  //query
end;

procedure TForm1.zqlistAfterScroll(DataSet: TDataSet);
begin
  if not zqlist.FieldByName('GodzinyID').IsNull then
  begin
    dtpd.DateTime := zqlist.FieldByName('Czas_rozpoczecia').AsDateTime;
    dtpst.DateTime := zqlist.FieldByName('Czas_rozpoczecia').AsDateTime;
    dtpet.DateTime := zqlist.FieldByName('Czas_zakonczenia').AsDateTime;
    eremarks.Text := zqlist.FieldByName('Uwagi').AsString;
  end;
end;

end.

